searchNodes=[{"doc":"Tarearbol module provides an interface to run tasks in easy way. Examples iex&gt; result = Tarearbol . ensure ( fn -&gt; raise &quot;¡?&quot; end , attempts : 1 , raise : false ) iex&gt; { :error , %{ job : _job , outcome : outcome } } = result iex&gt; { error , _stacktrace } = outcome iex&gt; error % RuntimeError { message : &quot;¡?&quot; }","ref":"Tarearbol.html","title":"Tarearbol","type":"module"},{"doc":"Executes all the scheduled tasks immediately, cleaning up the queue.","ref":"Tarearbol.html#drain/1","title":"Tarearbol.drain/1","type":"function"},{"doc":"Ensures the task to be completed; restarts it when necessary. Possible options: attempts [ default: :infinity ] Might be any of @Tarearbol.Utils.interval type ( 5 for five attempts, :random for the random amount etc) delay [ default: 1 msec ]. Might be any of @Tarearbol.Utils.interval type ( 1_000 or 1.0 for one second, :timeout for five seconds etc) on_success [ default: nil ], the function to be called on successful execution ( arity ∈ [0, 1] or tuple {Mod, fun} where fun is of arity zero or one.) When the arity of given function is 1 , the result of task execution is passed on_retry [ default: nil ], same as above, called on retries after insuccessful attempts or one of [:debug, :info, :warn, :error] atoms to log a retry with default logger on_fail [ default: nil ], same as above, called when the task finally failed after attempts amount of insuccessful attempts","ref":"Tarearbol.html#ensure/2","title":"Tarearbol.ensure/2","type":"function"},{"doc":"Same as Tarearbol.ensure/2 , but it raises on fail and returns the result itself on successful execution.","ref":"Tarearbol.html#ensure!/2","title":"Tarearbol.ensure!/2","type":"function"},{"doc":"Executes Tarearbol.ensure_all_streamed/2 and collects tasks results.","ref":"Tarearbol.html#ensure_all/2","title":"Tarearbol.ensure_all/2","type":"function"},{"doc":"Wrapper for Task.Supervisor.async_stream/4 .","ref":"Tarearbol.html#ensure_all_streamed/2","title":"Tarearbol.ensure_all_streamed/2","type":"function"},{"doc":"Runs a task specified by the first argument at a given time. If the second parameter is a [ DateTime ] struct, the task will be run once. If the second parameter is a [ Time ] struct, the task will be run at that time on daily basis.","ref":"Tarearbol.html#run_at/3","title":"Tarearbol.run_at/3","type":"function"},{"doc":"Runs a task specified by the first argument in a given interval. See [ Tarearbol.ensure/2 ] for all possible variants of the interval argument.","ref":"Tarearbol.html#run_in/3","title":"Tarearbol.run_in/3","type":"function"},{"doc":"Spawns the task for the immediate async execution.","ref":"Tarearbol.html#spawn/2","title":"Tarearbol.spawn/2","type":"function"},{"doc":"Spawns an ensured job asynchronously, passing all options given.","ref":"Tarearbol.html#spawn_ensured/2","title":"Tarearbol.spawn_ensured/2","type":"function"},{"doc":"The scaffold implementation to dynamically manage many similar tasks running as processes. It creates a main supervisor, managing the GenServer holding the state and DynamicSupervisor handling chidren. It has a strategy :rest_for_one , assuming that if the process holding the state crashes, the children will be restarted. Typically one calls use Tarearbol.DynamicManager and implements at least children_specs/0 callback and receives back supervised tree with a state and many processes controlled by DynamicSupervisor . To see how it works you might try defmodule DynamicManager do use Tarearbol.DynamicManager def children_specs do for i &lt;- 1 .. 10 , do : { &quot;foo_ \#{ i } &quot; , [ ] } , into : %{ } end end { :ok , pid } = DynamicManager . start_link ( ) The above would spawn 10 children with IDs &quot;foo_1&quot;..&quot;foo_10&quot; . Workers Management DynamicManager allows dynamic workers management. It exports three functions @spec get ( id :: id ( ) ) :: Enum . t ( ) @spec put ( id :: id ( ) , opts :: Enum . t ( ) ) :: pid ( ) @spec del ( id :: id ( ) ) :: :ok @spec restart ( id :: id ( ) ) :: :ok The semantics of put/2 arguments is the same as a single child_spec , del/1 and get/1 receive the unique ID of the child and shutdown it or return it’s payload respectively. Workers Callbacks Workers are allowed to implement several callbacks to be used to pass messages to them. peform/2 is called periodically by the library internals; the interval is set upon worker initialization via children_specs/1 (static) or put/2 (dynamic); the interval set to 0 suppresses periodic invocations call/3 to handle synchronous message send to worker cast/2 to handle asynchronous message send to worker terminate/2 to handle worker process termination All the above should return a value of Tarearbol.DynamicManager.response/0 type. Also, the implementing module might use a custom initialization function to e. g. dynamically build payload. Is should be passed to use DynamicManager as a parameter init: handler and might be a tuple {module(), function(), arity()} or a captured function &amp;MyMod.my_init/1 . Arities 0, 1 and 2 are allowed, as described by Tarearbol.DynamicManager.init_handler/0 type. The worker process will call this function from GenServer.handle_continue/2 callback.","ref":"Tarearbol.DynamicManager.html","title":"Tarearbol.DynamicManager","type":"behaviour"},{"doc":"The method to implement to support explicit GenServer.call/3 on the wrapping worker.","ref":"Tarearbol.DynamicManager.html#c:call/3","title":"Tarearbol.DynamicManager.call/3","type":"callback"},{"doc":"The method to implement to support explicit GenServer.cast/2 on the wrapping worker.","ref":"Tarearbol.DynamicManager.html#c:cast/2","title":"Tarearbol.DynamicManager.cast/2","type":"callback"},{"doc":"This function is called to retrieve the map of children with name as key and a workers as the value. The value must be an enumerable with keys among: :payload passed as second argument to perform/2 , default nil :timeout time between iterations of perform/2 , default 1 second :lull threshold to notify latency in performing, default 1.1 (the threshold is :lull times the :timeout ) This function should not care about anything save for producing side effects. It will be backed by DynamicSupervisor . The value it returns will be put into the state under children key.","ref":"Tarearbol.DynamicManager.html#c:children_specs/0","title":"Tarearbol.DynamicManager.children_specs/0","type":"callback"},{"doc":"Declares an instance-wide callback to report state; if the startup process takes a while, it’d be run in handle_continue/2 and this function will be called after it finishes so that the application might start using it. If the application is not interested in receiving state updates, e. g. when all it needs from runners is a side effect, there is a default implementation that does nothing.","ref":"Tarearbol.DynamicManager.html#c:handle_state_change/1","title":"Tarearbol.DynamicManager.handle_state_change/1","type":"callback"},{"doc":"Declares a callback to report slow process (when the scheduler cannot process in a reasonable time).","ref":"Tarearbol.DynamicManager.html#c:handle_timeout/1","title":"Tarearbol.DynamicManager.handle_timeout/1","type":"callback"},{"doc":"The main function, doing all the internal job, supervised. It will be called with the child id as first argument and the payload option to child spec as second argument (defaulting to nil , can also be ignored if not needed). Return values perform/2 might return :halt if it wants to be killed {:ok, result} to store the last result and reschedule with default timeout {:replace, payload} to replace the payload (state) of the current worker with the new one {:replace, id, payload} to replace the current worker with the new one {{:timeout, timeout}, result} to store the last result and reschedule in given timeout interval or deprecated anything else will be treated as a result","ref":"Tarearbol.DynamicManager.html#c:perform/2","title":"Tarearbol.DynamicManager.perform/2","type":"callback"},{"doc":"The method that will be called before the worker is terminated.","ref":"Tarearbol.DynamicManager.html#c:terminate/2","title":"Tarearbol.DynamicManager.terminate/2","type":"callback"},{"doc":"Identifier of the child process","ref":"Tarearbol.DynamicManager.html#t:id/0","title":"Tarearbol.DynamicManager.id/0","type":"type"},{"doc":"Post-instantion init handler type, that might be passed to use DynamicManager vis init:","ref":"Tarearbol.DynamicManager.html#t:init_handler/0","title":"Tarearbol.DynamicManager.init_handler/0","type":"type"},{"doc":"Payload associated with the worker","ref":"Tarearbol.DynamicManager.html#t:payload/0","title":"Tarearbol.DynamicManager.payload/0","type":"type"},{"doc":"Expected response from the DymanicManager implementation","ref":"Tarearbol.DynamicManager.html#t:response/0","title":"Tarearbol.DynamicManager.response/0","type":"type"},{"doc":"The internal representation of a child process under DynamicManager supervision","ref":"Tarearbol.DynamicManager.Child.html","title":"Tarearbol.DynamicManager.Child","type":"module"},{"doc":"","ref":"Tarearbol.DynamicManager.Child.html#t:t/0","title":"Tarearbol.DynamicManager.Child.t/0","type":"type"},{"doc":"The pool of workers built on top of Tarearbol.DynamicManager . Configuration options: pool_size the size of the pool, default: 5 payload the default payload for all the workers (for more complex initialization, use init option below) init custom init step as described in Tarearbol.DynamicManager docs This module exports defsynch/2 and defasynch/2 macros allowing to to declare functions that would be managed by a pool behind. Basically, the below would be translated into a message passed to the free worker of the pool. defsynch synch ( n ) do { :ok , payload! ( ) + n } end Both macros have three predefined functions declared inside a block id! returning the id of the worker invoked payload! returning the payload of the worker invoked state! returning the state of the worker invoked as a tuple {id, payload}","ref":"Tarearbol.Pool.html","title":"Tarearbol.Pool","type":"module"},{"doc":"Declares an asynchronous function with the same name and block, that will be under the hood routed to the free worker to execute. If there is no free worker at the moment, returns :error otherwise returns {:ok, result} tuple. This function might return any response recognizable by Tarearbol.DynamicManager.response/0 .","ref":"Tarearbol.Pool.html#defasynch/2","title":"Tarearbol.Pool.defasynch/2","type":"macro"},{"doc":"Declares a synchronous function with the same name and block, that will be under the hood routed to the free worker to execute. If there is no free worker at the moment, returns :error otherwise returns {:ok, result} tuple. This function might return any response recognizable by Tarearbol.DynamicManager.response/0 .","ref":"Tarearbol.Pool.html#defsynch/2","title":"Tarearbol.Pool.defsynch/2","type":"macro"},{"doc":"Handy functions to work with dates.","ref":"Tarearbol.Calendar.html","title":"Tarearbol.Calendar","type":"module"},{"doc":"Returns a DateTime instance of the beginning of the period given as third parameters, related to the DateTime instance given as the first parameter (defaulted to DateTime.utc_now/0 ). The number of periods to shift might be given as the second parameter (defaults to 0 .) Examples: iex&gt; dt = DateTime . from_unix! ( 1567091960 ) ~U[2019-08-29 15:19:20Z] iex&gt; Tarearbol.Calendar . beginning_of ( dt , :year ) ~U[2019-01-01 00:00:00Z] iex&gt; Tarearbol.Calendar . beginning_of ( dt , - 2 , :year ) ~U[2017-01-01 00:00:00Z] iex&gt; Tarearbol.Calendar . beginning_of ( dt , :month ) ~U[2019-08-01 00:00:00Z] iex&gt; Tarearbol.Calendar . beginning_of ( dt , 6 , :month ) ~U[2020-02-01 00:00:00Z] iex&gt; Tarearbol.Calendar . beginning_of ( dt , 4 , :day ) ~U[2019-09-02 00:00:00Z] iex&gt; Tarearbol.Calendar . beginning_of ( dt , :week ) ~U[2019-08-26 00:00:00Z] iex&gt; Tarearbol.Calendar . beginning_of ( dt , - 34 , :week ) ~U[2018-12-31 00:00:00Z] iex&gt; Tarearbol.Calendar . beginning_of ( dt , :hour ) ~U[2019-08-29 15:00:00Z] iex&gt; Tarearbol.Calendar . beginning_of ( dt , - 28 * 24 - 16 , :hour ) ~U[2019-07-31 23:00:00Z] iex&gt; Tarearbol.Calendar . end_of ( dt , :hour ) ~U[2019-08-29 15:59:59Z] iex&gt; Tarearbol.Calendar . end_of ( dt , 5 , :month ) ~U[2020-01-31 23:59:59Z] iex&gt; Tarearbol.Calendar . end_of ( dt , - 1 , :year ) ~U[2018-12-31 23:59:59Z]","ref":"Tarearbol.Calendar.html#beginning_of/3","title":"Tarearbol.Calendar.beginning_of/3","type":"function"},{"doc":"","ref":"Tarearbol.Calendar.html#end_of/3","title":"Tarearbol.Calendar.end_of/3","type":"function"},{"doc":"Helper functions to work with cron syntax.","ref":"Tarearbol.Crontab.html","title":"Tarearbol.Crontab","type":"module"},{"doc":"Produces the single formula out of cron record. Might be useful for some external check that requires the single validation call. Examples iex&gt; Tarearbol.Crontab . formula ( &quot;42 3 28 08 *&quot; ) . formula &quot;(day == 28) &amp;&amp; (rem(day_of_week, 1) == 0) &amp;&amp; (hour == 3) &amp;&amp; (minute == 42) &amp;&amp; (month == 8)&quot; iex&gt; Tarearbol.Crontab . formula ( &quot;423 * * * *&quot; ) { :error , [ minute : { :could_not_parse_field , [ &quot;423&quot; ] } ] }","ref":"Tarearbol.Crontab.html#formula/1","title":"Tarearbol.Crontab.formula/1","type":"function"},{"doc":"Returns the next DateTime the respective cron record points to with a precision given as the third argument (default: :second .) If the first parameter is not given, it assumes the next after now . Examples iex&gt; dt = DateTime . from_unix! ( 1567091960 ) ~U[2019-08-29 15:19:20Z] iex&gt; Tarearbol.Crontab . next ( dt , &quot;42 3 28 08 *&quot; ) [ origin : ~U[2019-08-29 15:19:20Z] , next : ~U[2020-08-28 03:42:00Z] , second : 31494160 ] where origin contains the timestamp to lookup the next for, next is the DateTime instance of the next event and second is the { precision , difference_in_that_precision }.","ref":"Tarearbol.Crontab.html#next/3","title":"Tarearbol.Crontab.next/3","type":"function"},{"doc":"Returns the list of all the events after dt (default: DateTime.utc_now/0 .) This function calculates the outcome greedily and, while it might be slightly faster than Tarearbol.Crontab.next_as_stream/3 , it should not be used for frequently recurring cron records (like &quot;* * * * *&quot; .)","ref":"Tarearbol.Crontab.html#next_as_list/3","title":"Tarearbol.Crontab.next_as_list/3","type":"function"},{"doc":"Returns the stream of all the events after dt (default: DateTime.utc_now/0 .) This function calculates the outcome lazily, returning a stream. See Tarearbol.Crontab.next_as_list/3 for greedy evaluation.","ref":"Tarearbol.Crontab.html#next_as_stream/3","title":"Tarearbol.Crontab.next_as_stream/3","type":"function"},{"doc":"Parses the cron string into human-readable representation. This function is exported for debugging purposes only, normally one would call prepare/1 instead. Input format: &quot;minute hour day/month month day/week&quot; . Examples: iex&gt; Tarearbol.Crontab . parse &quot;10-30/5 */4 1 */1 6,7&quot; % Tarearbol.Crontab { day : &quot;(day == 1)&quot; , day_of_week : &quot;(day_of_week == 6 || day_of_week == 7)&quot; , hour : &quot;(rem(hour, 4) == 0)&quot; , minute : &quot;(rem(minute, 5) == 0 &amp;&amp; minute &gt;= 10 &amp;&amp; minute &lt;= 30)&quot; , month : &quot;(rem(month, 1) == 0)&quot; } In case of malformed input: iex&gt; Tarearbol.Crontab . parse &quot;10-30/5 */4 1 */1 6d,7&quot; % Tarearbol.Crontab { day : &quot;(day == 1)&quot; , day_of_week : { :error , { :could_not_parse_integer , &quot;6d&quot; } } , hour : &quot;(rem(hour, 4) == 0)&quot; , minute : &quot;(rem(minute, 5) == 0 &amp;&amp; minute &gt;= 10 &amp;&amp; minute &lt;= 30)&quot; , month : &quot;(rem(month, 1) == 0)&quot; }","ref":"Tarearbol.Crontab.html#parse/1","title":"Tarearbol.Crontab.parse/1","type":"function"},{"doc":"Parses the cron string into Tarearbol.Crontab.t() struct. Input format: &quot;minute hour day/month month day/week&quot; .","ref":"Tarearbol.Crontab.html#prepare/1","title":"Tarearbol.Crontab.prepare/1","type":"function"},{"doc":"Converts the Time instance into daily-execution cron string","ref":"Tarearbol.Crontab.html#to_cron/1","title":"Tarearbol.Crontab.to_cron/1","type":"function"},{"doc":"Internal representation of the record in cron file","ref":"Tarearbol.Crontab.html#t:t/0","title":"Tarearbol.Crontab.t/0","type":"type"},{"doc":"Cron-like task scheduler. Accepts both static and dynamic configurations. Usage Add Tarearbol.Scheduler to the list of supervised workers. It would attempt to read the static configuration (see below) and start the DynamicSupervisor with all the scheduled jobs as supervised workers. The runner is the function of arity zero, that should return {:ok, result} tuple upon completion. The job will be rescheduled according to its schedule. The last result returned will be stored in the state and might be retrieved later with get/1 passing the job name. Static Configuration Upon starts it looks up :tarearbol section of Mix.Project for :jobs and :jobs_file keys. The latter has a default .tarearbol.exs . This won’t work with releases. Also it looks up :tarearbol, :jobs section of config.exs . Everything found is unioned. Jobs with the same names are overriden, the file has precedence over project config, the application config has least precedence. If found, jobs as a list of tuples of {name, runner, schedule} are scheduled. These are expected to be in the following form. name might be whatever, used to refer to the job during it’s lifetime runner might be either {module, function} tuple or a reference to the function of arity zero ( &amp;Foo.bar/0 ) schedule in standard cron notation, see https://crontab.guru Dynamic Configuration Use Tarearbol.Scheduler.push/3 , Tarearbol.Scheduler.pop/1 to add/remove jobs temporarily and/or Tarearbol.Scheduler.push!/3 , Tarearbol.Scheduler.pop!/1 to reflect changes in the configuration file. Tarearbol.Scheduler . push ( TestJob , &amp; Foo . bar / 0 , &quot;3-5/1 9-18 * * 6-7&quot; )","ref":"Tarearbol.Scheduler.html","title":"Tarearbol.Scheduler","type":"module"},{"doc":"","ref":"Tarearbol.Scheduler.html#active_jobs/0","title":"Tarearbol.Scheduler.active_jobs/0","type":"function"},{"doc":"Performs a GenServer.cast/2 to the worker specified by id . Tarearbol.DynamicManager.cast/2 callback should be implemented for this to work.","ref":"Tarearbol.Scheduler.html#asynch_call/2","title":"Tarearbol.Scheduler.asynch_call/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Tarearbol.Scheduler.html#child_spec/1","title":"Tarearbol.Scheduler.child_spec/1","type":"function"},{"doc":"Dynamically removes a supervised worker implementing Tarearbol.DynamicManager behaviour from the list of supervised children If distributed: true parameter was given to use Tarearbol.DynamicManager , deletes the worker from all the nodes managed by Cloister . :cloister dependency must be added to a project to use this feature.","ref":"Tarearbol.Scheduler.html#del/1","title":"Tarearbol.Scheduler.del/1","type":"function"},{"doc":"Retrieves the information ( payload , timeout , lull etc.) assotiated with the supervised worker","ref":"Tarearbol.Scheduler.html#get/1","title":"Tarearbol.Scheduler.get/1","type":"function"},{"doc":"Dynamically removes a supervised worker implementing Tarearbol.DynamicManager behaviour from the list of supervised children on all the nodes managed by Cloister . Use distributed: true parameter in call to use Tarearbol.DynamicManager and regular del/1 instead.","ref":"Tarearbol.Scheduler.html#multidel/1","title":"Tarearbol.Scheduler.multidel/1","type":"function"},{"doc":"Dynamically adds a supervised worker implementing Tarearbol.DynamicManager behaviour to the list of supervised children on all the nodes managed by Cloister . Use distributed: true parameter in call to use Tarearbol.DynamicManager and regular put/2 instead.","ref":"Tarearbol.Scheduler.html#multiput/2","title":"Tarearbol.Scheduler.multiput/2","type":"function"},{"doc":"Removes the scheduled job from the schedule by id . For the implementation that survives restarts use pop!/1 .","ref":"Tarearbol.Scheduler.html#pop/1","title":"Tarearbol.Scheduler.pop/1","type":"function"},{"doc":"Removes the scheduled job from the schedule by id and updated the configuration. For the implementation that removes jobs temporarily, use pop!/1 .","ref":"Tarearbol.Scheduler.html#pop!/1","title":"Tarearbol.Scheduler.pop!/1","type":"function"},{"doc":"Creates and temporarily pushes the job to the list of currently scheduled jobs. For the implementation that survives restarts use push!/3 .","ref":"Tarearbol.Scheduler.html#push/3","title":"Tarearbol.Scheduler.push/3","type":"function"},{"doc":"Creates and pushes the job to the list of currently scheduled jobs, updates the permanent list of scheduled jobs. For the implementation that temporarily pushes a job, use push/3 .","ref":"Tarearbol.Scheduler.html#push!/3","title":"Tarearbol.Scheduler.push!/3","type":"function"},{"doc":"Dynamically adds a supervised worker implementing Tarearbol.DynamicManager behaviour to the list of supervised children. If distributed: true parameter was given to use Tarearbol.DynamicManager , puts the worker into all the nodes managed by Cloister . :cloister dependency must be added to a project to use this feature.","ref":"Tarearbol.Scheduler.html#put/2","title":"Tarearbol.Scheduler.put/2","type":"function"},{"doc":"Restarts the DynamicManager to the clean state","ref":"Tarearbol.Scheduler.html#restart/0","title":"Tarearbol.Scheduler.restart/0","type":"function"},{"doc":"Starts the DynamicSupervisor and its helpers to manage dynamic children","ref":"Tarearbol.Scheduler.html#start_link/1","title":"Tarearbol.Scheduler.start_link/1","type":"function"},{"doc":"Performs a GenServer.call/3 to the worker specified by id . Tarearbol.DynamicManager.call/3 callback should be implemented for this to work.","ref":"Tarearbol.Scheduler.html#synch_call/2","title":"Tarearbol.Scheduler.synch_call/2","type":"function"},{"doc":"Type of possible job schedules to be run once: Time to be executed once or amount of milliseconds to execute after","ref":"Tarearbol.Scheduler.html#t:once_schedule/0","title":"Tarearbol.Scheduler.once_schedule/0","type":"type"},{"doc":"Type of possible job schedules to be run repeatedly: binary cron format or DateTime for the daily execution","ref":"Tarearbol.Scheduler.html#t:repeated_schedule/0","title":"Tarearbol.Scheduler.repeated_schedule/0","type":"type"},{"doc":"Type of the job runner, an {m, f} tuple or a function of arity zero, returning one of the outcomes below","ref":"Tarearbol.Scheduler.html#t:runner/0","title":"Tarearbol.Scheduler.runner/0","type":"type"},{"doc":"Combined type for the all schedules possible","ref":"Tarearbol.Scheduler.html#t:schedule/0","title":"Tarearbol.Scheduler.schedule/0","type":"type"},{"doc":"A struct holding the job description. Used internally by Tarearbol.Scheduler to preserve a list of scheduled jobs.","ref":"Tarearbol.Scheduler.Job.html","title":"Tarearbol.Scheduler.Job","type":"module"},{"doc":"Produces a Tarearbol.Scheduler.Job by parameters given","ref":"Tarearbol.Scheduler.Job.html#create/3","title":"Tarearbol.Scheduler.Job.create/3","type":"function"},{"doc":"The struct containing the information about the job","ref":"Tarearbol.Scheduler.Job.html#t:t/0","title":"Tarearbol.Scheduler.Job.t/0","type":"type"},{"doc":"The generic exception thrown from any function dealing with Task handling.","ref":"Tarearbol.TaskFailedError.html","title":"Tarearbol.TaskFailedError","type":"exception"},{"doc":"Scaffold for managing many children under Tarearbol.DynamicManager wrapping DynamicSupervisor with a pleasure Lightweight task manager, allowing retries, callbacks, assurance that the task succeeded, and more Lightweight scalable cron-like job scheduler Tarearbol.Scheduler","ref":"intro.html","title":"Tarearbol","type":"extras"},{"doc":"Features Scaffold for the supervised DynamicSupervisor No code for managing processes required Implementation is as easy as 4 callbacks Behaviour-driven consumers Consistent state and callbacks on state changes (like restarting) Dynamic Workers Management Examples","ref":"intro.html#dynamic-workers-management","title":"Tarearbol - Dynamic Workers Management","type":"extras"},{"doc":"Features Task supervision tree for granted Infinite retries until succeeded Async execution of a single task with retries Async execution of many tasks with retries Limited amount of retries Delay between retries Callbacks on on_retry , on_success , on_fail Configurable “success” treatment Task scheduling and draining, cron-like execution Task Management Examples","ref":"intro.html#task-management","title":"Tarearbol - Task Management","type":"extras"},{"doc":"Features Fully supported cron syntax Job callback with an ability to cancel and reschedule jobs Easy configuration via project, config, or external file No persistent storage required Stream with all the upcoming cron events by cron record Tarearbol.Calendar.{beginning_of,end_of}/2 with full Calendar support Job Management Examples","ref":"intro.html#job-management","title":"Tarearbol - Job Management","type":"extras"},{"doc":"","ref":"task_management.html","title":"Task Management","type":"extras"},{"doc":"Add :tarearbol to the list of applications and you are all set.","ref":"task_management.html#task-supervision-tree-for-granted","title":"Task Management - Task supervision tree for granted","type":"extras"},{"doc":"Tarearbol . ensure fn -&gt; unless Enum . random ( 1 .. 100 ) == 42 , do : raise &quot;Incorrect answer&quot; { :ok , 42 } end # some bad-case logging { :ok , 42 }","ref":"task_management.html#infinite-retries","title":"Task Management - Infinite retries","type":"extras"},{"doc":"Tarearbol . spawn_ensured ( { Process , :sleep , [ 1_000 ] } , attempts : 1 , on_success : { IO , :inspect , [ [ label : &quot;Result&quot; ] ] } ) % Task { owner : # PID &lt; 0 . 248 . 0 &gt; , pid : # PID &lt; 0 . 271 . 0 &gt; , ref : # Reference &lt; 0.1612468028 . 2321547270.14001 &gt; } # &lt;one second delay&gt; Result : :ok","ref":"task_management.html#async-execution-with-retries","title":"Task Management - Async execution with retries","type":"extras"},{"doc":"res = 1 .. 20 |&gt; Enum . map ( fn i -&gt; fn -&gt; Process . sleep ( Enum . random ( 1 .. i ) ) ; i end end ) |&gt; Tarearbol.Job . ensure_all ( attempts : 1 ) [ { :ok , 1 } , { :ok , 2 } , ... , { :ok , 20 } ] NB the above is synchronized against main process.","ref":"task_management.html#async-execution-of-many-tasks-with-retries","title":"Task Management - Async execution of many tasks with retries","type":"extras"},{"doc":"Tarearbol . ensure fn -&gt; raise &quot;Incorrect answer&quot; end , attempts : 10 # some bad-case logging { :error , %{ job : # Function &lt; 20.87737649 / 0 in :erl_eval . expr / 5 &gt; , outcome : { % RuntimeError { message : &quot;Incorrect answer&quot; } , [ { :erl_eval , :do_apply , 6 , [ file : &#39;erl_eval.erl&#39; , line : 668 ] } , { Task.Supervised , :do_apply , 2 , [ file : &#39;lib/task/supervised.ex&#39; , line : 85 ] } , { Task.Supervised , :reply , 5 , [ file : &#39;lib/task/supervised.ex&#39; , line : 36 ] } , { :proc_lib , :init_p_do_apply , 3 , [ file : &#39;proc_lib.erl&#39; , line : 247 ] } ] } } }","ref":"task_management.html#limited-amount-of-retries","title":"Task Management - Limited amount of retries","type":"extras"},{"doc":"Tarearbol . ensure fn -&gt; unless Enum . random ( 1 .. 100 ) == 42 , do : raise &quot;Incorrect answer&quot; { :ok , 42 } end , delay : 1000 # some slow bad-case logging { :ok , 42 }","ref":"task_management.html#delay-between-retries","title":"Task Management - Delay between retries","type":"extras"},{"doc":"Tarearbol . ensure fn -&gt; unless Enum . random ( 1 .. 100 ) == 42 , do : raise &quot;Incorrect answer&quot; { :ok , 42 } end , on_success : fn data -&gt; IO . inspect ( data , label : &quot;★&quot; ) end , on_retry : { IO , :inspect , [ [ label : &quot;☆&quot; ] ] } end # some slow bad-case logging # ⇓⇓⇓⇓ one or more of ⇓⇓⇓⇓ ☆ : %{ cause : :on_raise , data : { % RuntimeError { message : &quot;Incorrect answer&quot; } , [ { :erl_eval , :do_apply , 6 , [ file : &#39;erl_eval.erl&#39; , line : 670 ] } , { :erl_eval , :exprs , 5 , [ file : &#39;erl_eval.erl&#39; , line : 122 ] } , { Task.Supervised , :do_apply , 2 , [ file : &#39;lib/task/supervised.ex&#39; , line : 85 ] } , { Task.Supervised , :reply , 5 , [ file : &#39;lib/task/supervised.ex&#39; , line : 36 ] } , { :proc_lib , :init_p_do_apply , 3 , [ file : &#39;proc_lib.erl&#39; , line : 247 ] } ] } } # ⇑⇑⇑⇑ one or more of ⇑⇑⇑⇑ ★ : 42 { :ok , 42 }","ref":"task_management.html#callbacks","title":"Task Management - Callbacks","type":"extras"},{"doc":"attempts integer, an amount of attempts before giving up, 0 for forever; default: :infinity delay the delay between attempts, default: :none ; -  raise : when true , will raise after all attempts were unsuccessful, or return {:error, outcome} tuple otherwise, default: false ; accept_not_ok : when true , any result save for {:error, _} will be accepted as correct, otherwise only {:ok, _} is treated as correct, default: true ; on_success : callback when the task returned a result, default: nil ; on_retry : callback when the task failed and scheduled for retry, default: :debug ; on_fail : callback when the task completely failed, default: :warn . for :attempts and :delay keys one might specify the following values: integer → amount to be used as is (milliseconds for delay , number for attempts); float → amount of thousands, rounded (seconds for delay , thousands for attempts); :none → 0 ; :tiny → 10 ; :medium → 100 ; :infinity → -1 , :attempts only.","ref":"task_management.html#allowed-options","title":"Task Management - Allowed options","type":"extras"},{"doc":"Tarearbol . run_in fn -&gt; IO . puts ( 42 ) end , 1_000 # 1 sec Tarearbol . spawn fn -&gt; IO . puts ( 42 ) end # immediately","ref":"task_management.html#task-spawning","title":"Task Management - Task spawning","type":"extras"},{"doc":"Tarearbol . run_in fn -&gt; IO . inspect ( 42 ) end , 1_000 # 1 sec Tarearbol . run_in fn -&gt; IO . inspect ( :foo ) end , 1_000 # 1 sec Tarearbol . drain 42 # immediately, from `IO.inspect` :foo # immediately, from `IO.inspect` [ ok : 42 , ok : :foo ] # immediately, the returned value(s)","ref":"task_management.html#task-draining","title":"Task Management - Task draining","type":"extras"},{"doc":"","ref":"dynamic_workers_management.html","title":"Dynamic Workers Management","type":"extras"},{"doc":"There are some ready-to-use snippets collected here .","ref":"dynamic_workers_management.html#dynamic-management-examples","title":"Dynamic Workers Management - Dynamic Management Examples","type":"extras"},{"doc":"DynamicSupervisor is a very handy tool to manage many different task-like processes. It is used mostly when one does not know in advance how many processes are to be run, and the processes happen to appear based on some external conditions. A good example would be a web scraper; we might spawn a process per every new page we need to crawl and DynamicSupervisor would take care about restarting those failed. It might become slightly cumbersome for the projects requiring more-or-less same behaviour but when the supervised processes should perform some periodical job, maybe exit upon job outcome and be accessible by some id while they are running. For the contrived example, imagine the main dashboard that displays the state of all the computers, connected to the intranet. There are guests with notebooks, constantly connecting and disconneting. Let’s say we want to maintain a list of processes spying on our guests (please do not use this library that way, though.) We need to be able to query the processes for current state / stats by computer ID, say, MAC-address. The first wild guess would be to convert MACs to alphanumeric and then to atoms to give names to our workers. And then call them by name. This approach is not only naïve but also very dangerous. That way we’d DOS our ErlangVM with atoms. So yeah, the dictionary MAC → PID is to be stored somewhere else. So we already need to have a supervisor, managing the state and DynamicSupervisor , which in turn manages workers. Also, upon startup there is a warming period during which we probably do not want to show anything since the data might be inaccurate. This warming stage should be probably done from inside handle_continue/2 from some another process, and this process cannot be the state one due to restart strategy :rest_for_one , which is required to restart workers when the state has crashed. All the problems above are very similar for this kind of task. So, welcome DynamicSupervisor which solves all the problems above automagically, leaving the consumer with a pure business logic implementation. The only needed thing to make it all up and running would be to implement Tarearbol.DynamicManager behaviour. It consists of four functions. children_specs/0 @callback children_specs :: %{ required ( binary ( ) ) =&gt; Enum . t ( ) } Return value should be a map of id → settings where id is the unique identifier of the process and possible settings values are described in the documentation. perform/2 @callback perform ( id :: binary ( ) , payload :: term ( ) ) :: any ( ) The implementation of the worker. This function will be called with the child id as first argument and the payload option to child spec as second argument. If it returns :halt , the process is considered done his job. Any other outcome will be treated as as a result and stored in the State . handle_state_change/1 @callback handle_state_change ( state :: :down | :up | :starting | :unknown ) :: :ok | :restart This callback will be called on state changes, like :starting while the initial state is not yet fully loaded and :started upon readyness. handle_timeout/1 @callback handle_timeout ( state :: map ( ) ) :: any ( ) This callback will be called if the worker cannot process in a reasonable time.","ref":"dynamic_workers_management.html#architecture","title":"Dynamic Workers Management - Architecture","type":"extras"},{"doc":"","ref":"dynamic_management_examples.html","title":"Dynamic Management Examples","type":"extras"},{"doc":"defmodule Counter do alias Tarearbol.DynamicManager use DynamicManager @impl DynamicManager def children_specs do now = DateTime . utc_now ( ) %{ second : [ payload : now , timeout : 1_000 ] , minute : [ payload : now , timeout : 60_000 ] } end @impl DynamicManager def perform ( :second , payload ) do now = DateTime . utc_now ( ) IO . inspect ( { payload , now } , label : &quot;sec&quot; ) { :ok , now } # do not replace a payload end def perform ( :minute , payload ) do now = DateTime . utc_now ( ) IO . inspect ( { payload , now } , label : &quot;min&quot; ) { :replace , now } # replace a payload end end Once started with Counter.start_link() , it’ll output: sec : { ~U[2021-03-10 07:58:55.874591Z] , ~U[2021-03-10 07:58:56.876633Z] } ... sec : { ~U[2021-03-10 07:58:55.874591Z] , ~U[2021-03-10 07:59:54.938543Z] } min : { ~U[2021-03-10 07:58:55.874591Z] , ~U[2021-03-10 07:59:55.876592Z] } sec : { ~U[2021-03-10 07:58:55.874591Z] , ~U[2021-03-10 07:59:55.939661Z] } ... sec : { ~U[2021-03-10 07:58:55.874591Z] , ~U[2021-03-10 08:00:54.998537Z] } min : { ~U[2021-03-10 07:59:55.876592Z] , ~U[2021-03-10 08:00:55.877658Z] } ... Note, that the payload of the :second one does not change, while the payload of minute gets updated to the latest value reported.","ref":"dynamic_management_examples.html#schedule-work","title":"Dynamic Management Examples - Schedule Work","type":"extras"},{"doc":"One might create a workers pool with a help of Tarearbol.DynamicManager . Usually perform/2 is suppressed in workers with timeout: 0 and only Genserver.cast/2 and Genserver.call/2 are handled with helpers Tarearbol.Pool.defsynch/2 and Tarearbol.Pool.defasynch/2 . Written as a regular functions, they are wrapped during compilation time to be dispatched to the free instance of the pool behind. Inside the body of these functions, the following magic macros become available: id! returning the id of the worker invoked payload! returning the payload of the worker invoked state! returning the state of the worker invoked as a tuple {id, payload} defmodule Pool do use Tarearbol.Pool , init : &amp; Pool . initializer / 0 , pool_size : 2 def initializer , do : 0 defsynch synch ( ) , do : { :ok , payload! ( ) } defsynch synch ( n ) , do : { :ok , payload! ( ) + n } defasynch asynch ( n ) , do : { :replace , payload! ( ) + n } end Now one might call Pool.synch/1 to perform a synchronized pooled state request, as well as Pool.asynch/1 to asynchronously update the state. Note, that in this contrived example, the state of the first free worker is going to be updated. Pool . start_link ( ) Enum . map ( 1 .. 3 , &amp; Pool . synch ( &amp;1 ) ) #⇒ [ok: 1, ok: 2, ok: 3] Pool . synch ( ) #⇒ 0 But for asynch/1 function that needs some time to finish and updates the state, it’s different. Pool . start_link ( ) Enum . map ( 1 .. 3 , &amp; Pool . asynch ( &amp;1 ) ) #⇒ [:ok, :ok, :ok] Enum . reduce ( Pool . state ( ) . children , 0 , &amp; &amp;2 + elem ( &amp;1 , 1 ) . value ) #⇒ 6 Note, that there is no guarantee what worker would handle each call.","ref":"dynamic_management_examples.html#workers-pool","title":"Dynamic Management Examples - Workers Pool","type":"extras"},{"doc":"Consider we are building an online shop having buckets for each customer. Then we might back up the customer session with this kind of DynamicManager . defmodule Bucket do alias Tarearbol.DynamicManager use DynamicManager def new ( customer ) do put ( customer , payload : %{ } , timeout : 10_000 ) end def do_smth ( customer ) do IO . inspect ( &quot;Hey, \#{ customer } , we have a discount&quot; ) end @impl DynamicManager def children_specs , do : %{ } @impl DynamicManager def perform ( id , payload ) do if map_size ( payload ) &gt; 0 , do : do_smth ( id ) { :ok , DateTime . utc_now ( ) } end @impl DynamicManager def call ( :&lt; , _from , { _id , payload } ) , do : { :ok , payload } @impl DynamicManager def cast ( { :+ , item } , { _id , payload } ) , do : { :replace , Map . update ( payload , item , 1 , &amp; &amp;1 + 1 ) } end Then we can play with it. iex | 1 ▸ Bucket . start_link ( ) { :ok , # PID &lt; 0 . 325 . 0 &gt; } iex | 2 ▸ Bucket . new &quot;Aleksei&quot; :ok iex | 3 ▸ Bucket . synch_call &quot;Aleksei&quot; , { :+ , :tomato } iex | 4 ▸ Bucket . asynch_call &quot;Aleksei&quot; , { :+ , :tomato } iex | 5 ▸ Bucket . asynch_call &quot;Aleksei&quot; , { :+ , :cucumber } # the below is printed from `perform/2` &quot;Hey, Aleksei, we have a discount&quot; iex | 6 ▸ Bucket . synch_call &quot;Aleksei&quot; , :&lt; { :ok , %{ cucumber : 1 , tomato : 2 } }","ref":"dynamic_management_examples.html#multiple-stateful-processes","title":"Dynamic Management Examples - Multiple Stateful Processes","type":"extras"},{"doc":"","ref":"cron_management.html","title":"Cron Management","type":"extras"},{"doc":"Tarearbol provides a simple but robust support of cron-like jobs scheduling. The approach is to spawn a process for each job to be completed under Tarearbol.DynamicManager supervision. Tarearbol application does not start the Tarearbol.Scheduler automatically, the target application must include it into it’s supervision tree explicitly. Jobs description are loaded upon application start from one of the following locations: project section of the Mix.Project , key :tarearbol , subkey :jobs config entry in Config script, key :tarearbol , subkey :jobs .tarearbol.exs file in the root folder of the target project (the path to the file might be configured in project section of the Mix.Project , key :tarearbol , subkey :jobs_file ) Tarearbol.Scheduler understands cron format. It exports three handy methods from Tarearbol.Crontab module, Tarearbol.Crontab.next/3 , Tarearbol.Crontab.next_as_stream/3 and Tarearbol.Crontab.next_as_list/3 . The first might be used to get the timestamp of the next event by cron record, the second to greedy evaluate all the next events for the year and the last one to return a Stream lazily evaluating next events.","ref":"cron_management.html#intro","title":"Cron Management - Intro","type":"extras"},{"doc":"Tarearbol.Scheduler was created mostly for the single-node application, but it might be easily extended to manage jobs on several nodes. Upon start, it loads jobs schedules and spawns processes for each, managed by Tarearbol.DynamicManager . Each job must return on of the following three outcomes. {:ok, any()} to normally return the result to be stored as last job execution result in the state of Manager and reschedule the job to the next event :halt to prevent further job executions and remove it from the list of scheduled jobs {{:reschedule, binary()}, any()} to reschedule the job with new cron record, given as the second parameter of the first tuple.","ref":"cron_management.html#job-management","title":"Cron Management - Job Management","type":"extras"},{"doc":"Tarearbol.Calendar exposes two functions stolen from Rails : Tarearbol.Calendar.beginning_of/2 returns the beginning of the period including the timestamp given as an argument Tarearbol.Calendar.end_of/2 returns the end of the period including the timestamp.","ref":"cron_management.html#extra-sugar","title":"Cron Management - Extra Sugar","type":"extras"}]